Index: sources/client/src/components/user/Session/SessionUser/index.js
===================================================================
--- sources/client/src/components/user/Session/SessionUser/index.js	(revision 747e0ab7ec1a73abedd264cf9b326ea140f54964)
+++ sources/client/src/components/user/Session/SessionUser/index.js	(revision 747e0ab7ec1a73abedd264cf9b326ea140f54964)
@@ -0,0 +1,210 @@
+import { useState } from 'react';
+import {
+    SessionInfo,
+    PlateSelectInput,
+    PlateAndAddPlateBtnWrapper,
+    ZoneSelectInput,
+    DropdownItem,
+    AddIcon,
+    AddPlate,
+    Input,
+    SavePlate,
+    SaveIcon,
+    PlateDropdownItem,
+    RemoveIcon,
+} from './styles';
+
+import { sessionStatus as enumsSessionStatus } from '../../../../config/enums';
+import useForm from '../../../../hooks/useForm';
+import useSaveUserPlate from '../../../../hooks/useSaveUserPlate';
+import useDeleteUserPlate from '../../../../hooks/useDeleteUserPlate';
+import AbsoluteLoader from '../../../Loaders/AbsoluteLoader';
+import { IconButton } from '@mui/material';
+import useGetData from '../../../../hooks/useGetData';
+
+const MenuProps = {
+    PaperProps: {
+        style: {
+            maxHeight: 150,
+            width: '35px',
+        },
+    },
+};
+
+const SessionUser = ({
+    sessionStatus,
+    zones,
+    data,
+    onFormChange,
+    setNewData,
+}) => {
+    const { data: plates, isLoading: isLoadingPlates, setData: setPlates } = useGetData({
+        url: '/registiranParkirac/tablici',
+    });
+    const [newPlate, setNewPlate] = useState('');
+    const [toggleAddPlate, setToggleAddPlate] = useState(false);
+    const { saveUserPlate } = useSaveUserPlate();
+    const { deleteUserPlate } = useDeleteUserPlate();
+    const [isLoadingSavePlate, setIsLoadingSavePlate] = useState(false);
+    const [isLoadingDeletePlate, setIsLoadingDeletePlate] = useState({
+        state: false,
+        itemInd: null,
+    });
+    const savePlate = (plate) => {
+        setPlates(prevState => [...prevState, plate]);
+        setToggleAddPlate(false);
+        setNewData({ ...data, plate: newPlate });
+        setNewPlate('');
+    };
+
+    const handleSavePlate = () => {
+        saveUserPlate({
+            savePlate,
+            plate: newPlate,
+            setIsLoadingSavePlate,
+        });
+    };
+
+    const deletePlate = (plate) => {
+        let index = plates.indexOf(plate);
+        let _plates = [...plates];
+        _plates.splice(index, 1);
+        if (_plates.length > index) {
+            setNewData({ ...data, plate: _plates[index] });
+        } else {
+            index--;
+            if (_plates.length !== 0) {
+                setNewData({
+                    ...data,
+                    plate: _plates[_plates.length - 1],
+                });
+            } else {
+                setNewData({ ...data, plate: 'NONE' });
+            }
+        }
+        setPlates(_plates);
+    };
+
+    const handleDeletePlate = (e, plate) => {
+        e.stopPropagation();
+        let ind = plates.indexOf(plate);
+        deleteUserPlate({ deletePlate, plate, ind, setIsLoadingDeletePlate });
+    };
+
+    return (
+        <SessionInfo>
+            <PlateAndAddPlateBtnWrapper
+                center={sessionStatus !== null}
+            >
+                {!toggleAddPlate ? (
+                    <PlateSelectInput
+                        MenuProps={MenuProps}
+                        name='plate'
+                        onChange={onFormChange}
+                        value={data.plate}
+                        renderValue={(v) => v}
+                        inputProps={{
+                            readOnly:
+                                sessionStatus === null
+                                    ? false
+                                    : true,
+                        }}
+                        $show={sessionStatus === null}
+                    >
+                        <DropdownItem value='NONE'>
+                            <em>NONE</em>
+                        </DropdownItem>
+                        {!isLoadingPlates &&
+                            plates.map((p, ind) => (
+                                <PlateDropdownItem key={ind} value={p}>
+                                    {p}
+                                    {isLoadingDeletePlate.state &&
+                                    isLoadingDeletePlate.itemInd === ind ? (
+                                        <AbsoluteLoader
+                                            containerStyle={{
+                                                width: '41.19px',
+                                                height: '41.19px',
+                                            }}
+                                        />
+                                    ) : (
+                                        <IconButton
+                                            style={{
+                                                padding: '3px',
+                                                zIndex: 100,
+                                            }}
+                                            onClick={(e) =>
+                                                handleDeletePlate(e, p, ind)
+                                            }
+                                        >
+                                            <RemoveIcon />
+                                        </IconButton>
+                                    )}
+                                </PlateDropdownItem>
+                            ))}
+                    </PlateSelectInput>
+                ) : (
+                    <Input
+                        autoFocus
+                        disabled={
+                            sessionStatus === null
+                                ? false
+                                : true
+                        }
+                        name='newPlate'
+                        style={{
+                            width: '49%',
+                            textAlign: 'center',
+                        }}
+                        value={newPlate}
+                        onChange={(e) => setNewPlate(e.target.value)}
+                    />
+                )}
+                {sessionStatus === null ? (
+                    !toggleAddPlate ? (
+                        <AddPlate onClick={() => setToggleAddPlate(true)}>
+                            <AddIcon />
+                            таблица
+                        </AddPlate>
+                    ) : isLoadingSavePlate ? (
+                        <AbsoluteLoader
+                            containerStyle={{
+                                width: '59.44px',
+                                height: '59.44px',
+                                margin: 'auto',
+                            }}
+                        />
+                    ) : (
+                        <SavePlate onClick={handleSavePlate}>
+                            <SaveIcon />
+                            сочувај
+                        </SavePlate>
+                    )
+                ) : null}
+            </PlateAndAddPlateBtnWrapper>
+            <ZoneSelectInput
+                MenuProps={MenuProps}
+                name='zone'
+                onChange={onFormChange}
+                value={data.zone}
+                inputProps={{
+                    readOnly:
+                        sessionStatus === null
+                            ? false
+                            : true,
+                }}
+                $show={sessionStatus === null}
+            >
+                <DropdownItem value='NONE'>
+                    <em>NONE</em>
+                </DropdownItem>
+                {zones.map((z, ind) => (
+                    <DropdownItem key={ind} value={z}>
+                        {z}
+                    </DropdownItem>
+                ))}
+            </ZoneSelectInput>
+        </SessionInfo>
+    );
+};
+
+export default SessionUser;
Index: sources/client/src/components/user/Session/SessionUser/styles.js
===================================================================
--- sources/client/src/components/user/Session/SessionUser/styles.js	(revision 747e0ab7ec1a73abedd264cf9b326ea140f54964)
+++ sources/client/src/components/user/Session/SessionUser/styles.js	(revision 747e0ab7ec1a73abedd264cf9b326ea140f54964)
@@ -0,0 +1,162 @@
+import styled from 'styled-components';
+import TextField from '@mui/material/TextField';
+import Button from '@mui/material/Button';
+import AddCircleOutlineIcon from '@mui/icons-material/AddCircleOutline';
+import RemoveCircleIcon from '@mui/icons-material/RemoveCircle';
+import SaveI from '@mui/icons-material/Save';
+import { MenuItem, Select } from '@mui/material';
+
+export const SessionInfo = styled.div`
+    display: flex;
+    flex-direction: column;
+    align-items: center;
+    padding: 5vh 25px 15px 25px;
+    margin-bottom: 6.5vh;
+`;
+
+export const Input = styled(TextField).attrs({
+    fullWidth: true,
+})`
+    height: 59.44px;
+    input {
+        text-align: center;
+        color: white !important;
+        font-size: 1.2rem;
+        padding-left: 10px;
+
+        ::placeholder {
+            opacity: 0.6;
+        }
+        :disabled {
+            -webkit-text-fill-color: white;
+        }
+    }
+    fieldset {
+        border: 0;
+        border-bottom: 4px solid white !important;
+        border-radius: 25px;
+        padding: 0 10px;
+    }
+`;
+
+export const PlateAndAddPlateBtnWrapper = styled.div`
+    display: flex;
+    flex-direction: row;
+    justify-content: ${(props) => (props.center ? 'center' : 'space-between')};
+    align-items: flex-end;
+    width: 100%;
+    margin-bottom: 5vh;
+    .MuiCircularProgress-svg {
+        color: ${(props) => props.theme.palette.third.main};
+    }
+`;
+
+export const ZoneSelectInput = styled(Select).attrs({})`
+    text-align: center;
+    position: relative;
+    width: 49%;
+    color: white;
+    #mui-component-select-zone {
+        font-size: 1.5rem;
+        padding: 16.5px 30px 16.5px 10px;
+        color: white !important;
+        font-size: 1.2rem;
+
+        ::placeholder {
+            opacity: 0.6;
+        }
+        :disabled {
+            -webkit-text-fill-color: white;
+        }
+    }
+    svg {
+        right: 10px;
+        color: white !important;
+        display: ${(props) => (!props.$show ? 'none' : '')};
+    }
+    fieldset {
+        border: 0;
+        border-bottom: 4px solid white !important;
+        border-radius: 25px;
+        padding: 0 10px;
+    }
+`;
+
+export const PlateSelectInput = styled(ZoneSelectInput)`
+    color: white;
+    font-weight: 500;
+    font-size: 1.15rem;
+`;
+
+export const DropdownItem = styled(MenuItem).attrs({})`
+    justify-content: center;
+    border-top: 1px solid grey;
+    :first-of-type {
+        border: 0;
+    }
+`;
+
+export const PlateDropdownItem = styled(MenuItem).attrs({})`
+    justify-content: space-between;
+    border-top: 1px solid grey;
+    padding-right: 5px;
+    padding-left: 10px;
+    :first-of-type {
+        border: 0;
+    }
+`;
+
+export const AddIcon = styled(AddCircleOutlineIcon).attrs({
+    sx: {
+        fontSize: '2.5rem',
+    },
+})`
+    margin-right: 11px;
+`;
+
+export const RemoveIcon = styled(RemoveCircleIcon).attrs({
+    sx: {
+        fontSize: '2.2rem',
+        color: 'red',
+    },
+})``;
+
+export const SaveIcon = styled(SaveI).attrs({
+    sx: {
+        fontSize: '2.5rem',
+    },
+})`
+    margin-right: 11px;
+`;
+
+export const AddPlate = styled(Button).attrs((props) => ({
+    variant: 'contained',
+    size: 'small',
+    sx: {
+        backgroundColor: `whiteSmoke`,
+        color: `${props.theme.palette.primary.main}`,
+        fontWeight: 600,
+        fontSize: 16,
+        height: 59.44,
+    },
+}))`
+    :hover {
+        background-color: #dcdcdc;
+    }
+`;
+
+export const SavePlate = styled(Button).attrs((props) => ({
+    variant: 'contained',
+    size: 'small',
+    sx: {
+        backgroundColor: `whiteSmoke`,
+        color: `${props.theme.palette.third.main}`,
+        fontWeight: 600,
+        fontSize: 16,
+        height: 59.44,
+    },
+}))`
+    :hover {
+        background-color: #dcdcdc;
+    }
+`;
Index: sources/client/src/components/user/Session/index.js
===================================================================
--- sources/client/src/components/user/Session/index.js	(revision 747e0ab7ec1a73abedd264cf9b326ea140f54964)
+++ sources/client/src/components/user/Session/index.js	(revision 747e0ab7ec1a73abedd264cf9b326ea140f54964)
@@ -0,0 +1,386 @@
+import { useState, useEffect, useContext, useRef, useMemo } from 'react';
+import moment from 'moment';
+
+import SessionGuest from './SessionGuest';
+import SessionUser from './SessionUser';
+import Buttons from './Buttons';
+import AbsoluteLoader from '../../Loaders/AbsoluteLoader';
+import { IconButton, Slide } from '@mui/material';
+import Radio from '@mui/material/Radio';
+import RadioGroup from '@mui/material/RadioGroup';
+import FormControlLabel from '@mui/material/FormControlLabel';
+import {
+    Wrapper,
+    ButtonWrapper,
+    ModalContainer,
+    CloseIcon,
+    KeyValueWrapper,
+    Key,
+    Value,
+    PaymentMethodWrapper,
+    PayWithText,
+    PaymentMethodsWrapper,
+    PayButtonWrapper,
+    ModalPayButton,
+    CardDetails,
+    DateAndCCVWrapper,
+    ModalInput,
+    CreditCard,
+    ModalInputCardNumber,
+} from './styles';
+import Modal from '@mui/material/Modal';
+import Backdrop from '@mui/material/Backdrop';
+
+import {
+    roles,
+    sessionStatus as enumsSessionStatus,
+} from '../../../config/enums';
+import theme from '../../../theme';
+import { UserContext } from '../../../context/UserContext';
+import useUserStartSession from '../../../hooks/useUserStartSession';
+import useForm from '../../../hooks/useForm';
+import useUserFinishedSession from '../../../hooks/useUserFinishedSession';
+import useUserPayForSession from '../../../hooks/useUserPayForSession';
+import useGetSessionOverInfo from '../../../hooks/useGetSessionOverInfo';
+import useGetData from '../../../hooks/useGetData';
+
+import { convertMinutesToString } from '../../../utils/convertMinToString';
+
+const normalizeSesionData = session => ({
+    plate: session?.plate?.plate ?? '',
+    zone: session?.parkingZone?.pzName ?? ''
+});
+
+const defaultTime = 15000;
+const Session = () => {
+    // const [timer, setTimer] = useState(10000);
+    // let timer = 10000;
+    // const timerInterval = setInterval(() => {
+    //     console.log('VIKTOR', timer);
+    //     // setTimer(defaultTime);
+    //     timer = 15000;
+    // }, timer);
+    // useEffect(() => {
+    //     return () => {
+    //         clearInterval(timerInterval);
+    //     }
+    // })
+    const { data: fetchedSelectZones, isLoading: isLoadingSelectZones } =
+        useGetData({ url: '/parkingZone/parkingZoneNames' });
+    const { user } = useContext(UserContext);
+    const [isModalOpen, setModalOpen] = useState(false);
+    const [paymentMethod, setPaymentMethod] = useState('');
+    const [cardNumber, setCardNumber] = useState('');
+    const [cardExpDate, setCardExpDate] = useState('');
+    const [cardCCV, setCardCCV] = useState('');
+    const { data: session, isLoading: isLoadingSession, setData: setSession } = useGetData({
+        url: '/parkingSession',
+    });
+    console.log('SESSION', session);
+    const {
+        data: userSessionInfo,
+        onFormChange: onFormChangeUserSessionInfo,
+        setNewData: setNewUserSessionData,
+    } = useForm({
+        plate: 'NONE',
+        zone: 'NONE',
+    });
+    const { userFinishedSession } = useUserFinishedSession();
+    const timerRef = useRef(0);
+    const { userStartSession } = useUserStartSession();
+    const { userPayForSession, isLoading: isLoadingPayForSession } =
+        useUserPayForSession();
+    const {
+        getSessionInfoOver,
+        isLoading: isLoadingSessionInfoOver,
+        totalPrice,
+    } = useGetSessionOverInfo();
+    const cardNumberHandler = (e) => {
+        const newVal = e.target.value.replace(/\s+/g, '');
+        let parts = [];
+        for (let i = 0; i < newVal.length; i += 4) {
+            parts.push(newVal.substring(i, i + 4));
+        }
+        console.log(parts);
+        if (parts.length) {
+            setCardNumber(parts.join(' '));
+        } else {
+            setCardNumber(newVal);
+        }
+    };
+
+    const cardExpDateHandler = (e) => {
+        const newVal = e.target.value.replace(/[^0-9]/, '');
+        let first = newVal.substring(0, 2);
+        let second = newVal.substring(2, 4);
+        if (second !== '') {
+            setCardExpDate([first, second].join('/'));
+        } else {
+            setCardExpDate(newVal);
+        }
+    };
+
+    const handleStartSession = () => {
+        userStartSession({ sessionData: userSessionInfo, setSession });
+    };
+
+    const handleEndSession = () => {
+        userFinishedSession({ setSession });
+    };
+
+    const handlePayForSession = () => {
+        if (paymentMethod) {
+            if (
+                paymentMethod === 'card' &&
+                (cardNumber === '' || cardCCV === '' || cardExpDate === '')
+            ) {
+                return;
+            }
+            let paymentCredentials = null;
+            if (paymentMethod === 'card') {
+                paymentCredentials = {
+                    cardNumber: cardNumber,
+                    cardExpDate: cardExpDate,
+                    cardCCV: cardCCV,
+                };
+            }
+            userPayForSession({
+                method: paymentMethod,
+                paymentCredentials,
+            });
+        }
+    };
+
+    const checkForDoubleClick = (e) => {
+        timerRef.current++;
+        setTimeout(() => {
+            if (timerRef.current !== 0) {
+                timerRef.current = 0;
+            }
+        }, 500);
+        if (timerRef.current >= 2) {
+            timerRef.current = 0;
+            if (!session) {
+                handleStartSession();
+            } else if (
+                session.status === enumsSessionStatus.active ||
+                session.status === enumsSessionStatus.idle
+            ) {
+                handleEndSession();
+            }
+        }
+    };
+
+    const handlePayButton = () => {
+        setModalOpen(true);
+        if (totalPrice) return; // don't send request if they are already set
+        getSessionInfoOver();
+    };
+
+    useEffect(() => {
+        if(session) {
+            setNewUserSessionData(normalizeSesionData(session));
+        }
+    }, [session])
+
+    const totalTime = useMemo(() => {
+        if(session?.timeEnd && session?.timeStart) {
+            const start = moment(session.timeStart);
+            const end = moment(session.timeEnd);
+            const diffMin = Math.round(end.diff(start) / 60000);
+            return convertMinutesToString(diffMin);
+        }
+        return null;
+    }, [session])
+
+    return (
+        <>
+            <Modal
+                open={isModalOpen}
+                onClose={() => {
+                    setModalOpen(false);
+                }}
+                closeAfterTransition
+                BackdropComponent={Backdrop}
+                BackdropProps={{
+                    timeout: 500,
+                }}
+                style={{
+                    display: 'flex',
+                    alignItems: 'center',
+                    justifyContent: 'center',
+                }}
+            >
+                <Slide in={isModalOpen}>
+                    <ModalContainer>
+                        <IconButton
+                            style={{
+                                marginLeft: 295,
+                            }}
+                            onClick={() => {
+                                setModalOpen(false);
+                            }}
+                        >
+                            <CloseIcon />
+                        </IconButton>
+                        {isLoadingSessionInfoOver ? ( // TODO FETCH SESSION DATA
+                            <AbsoluteLoader
+                                containerStyle={{
+                                    width: '200px',
+                                    height: '200px',
+                                    margin: 'auto',
+                                    marginTop: '50px',
+                                }}
+                            />
+                        ) : (
+                            <>
+                                <KeyValueWrapper>
+                                    <Key>Време:</Key>
+                                    <Value>{totalTime}</Value>
+                                </KeyValueWrapper>
+                                <KeyValueWrapper>
+                                    <Key>Вкупна сума:</Key>
+                                    <Value>{totalPrice} ден.</Value>
+                                </KeyValueWrapper>
+                                <PaymentMethodWrapper>
+                                    <PayWithText>Плати со:</PayWithText>
+                                    <PaymentMethodsWrapper>
+                                        <RadioGroup
+                                            aria-label='payment-methods'
+                                            name='payment-method'
+                                            value={paymentMethod}
+                                            onChange={(e) =>
+                                                setPaymentMethod(e.target.value)
+                                            }
+                                        >
+                                            <FormControlLabel
+                                                value='mobile'
+                                                control={
+                                                    <Radio
+                                                        sx={{
+                                                            color: theme.palette
+                                                                .primary.main,
+                                                            '&.Mui-checked': {
+                                                                color: theme
+                                                                    .palette
+                                                                    .primary
+                                                                    .main,
+                                                            },
+                                                        }}
+                                                    />
+                                                }
+                                                label='Мобилен'
+                                                labelPlacement='start'
+                                            />
+                                            <FormControlLabel
+                                                value='card'
+                                                control={
+                                                    <Radio
+                                                        sx={{
+                                                            color: theme.palette
+                                                                .primary.main,
+                                                            '&.Mui-checked': {
+                                                                color: theme
+                                                                    .palette
+                                                                    .primary
+                                                                    .main,
+                                                            },
+                                                        }}
+                                                    />
+                                                }
+                                                label='Картичка'
+                                                labelPlacement='start'
+                                            />
+                                        </RadioGroup>
+                                    </PaymentMethodsWrapper>
+                                </PaymentMethodWrapper>
+                                {paymentMethod === 'card' ? (
+                                    <CardDetails>
+                                        <ModalInputCardNumber
+                                            InputProps={{
+                                                startAdornment: <CreditCard />,
+                                            }}
+                                            onChange={cardNumberHandler}
+                                            value={cardNumber}
+                                        />
+                                        <DateAndCCVWrapper>
+                                            <ModalInput
+                                                InputProps={{
+                                                    placeholder: 'Exp: 11/21',
+                                                }}
+                                                style={{
+                                                    width: '45%',
+                                                }}
+                                                onChange={cardExpDateHandler}
+                                                value={cardExpDate}
+                                            />
+                                            <ModalInput
+                                                InputProps={{
+                                                    placeholder: 'CCV',
+                                                }}
+                                                style={{ width: '35%' }}
+                                                value={cardCCV}
+                                                onChange={(e) =>
+                                                    setCardCCV(e.target.value)
+                                                }
+                                            />
+                                        </DateAndCCVWrapper>
+                                    </CardDetails>
+                                ) : null}
+                                <PayButtonWrapper>
+                                    {isLoadingPayForSession ? (
+                                        <AbsoluteLoader
+                                            containerStyle={{
+                                                width: '51px',
+                                                height: '51px',
+                                                margin: 'auto',
+                                            }}
+                                        />
+                                    ) : (
+                                        <ModalPayButton
+                                            onClick={handlePayForSession}
+                                        >
+                                            Плати
+                                        </ModalPayButton>
+                                    )}
+                                </PayButtonWrapper>
+                            </>
+                        )}
+                    </ModalContainer>
+                </Slide>
+            </Modal>
+            {!isLoadingSession && (
+                <Wrapper>
+                    {user.role === roles.user ? (
+                        <SessionUser
+                            sessionStatus={session?.status ?? null}
+                            sessionInfo={normalizeSesionData(session)}
+                            zones={fetchedSelectZones ?? []}
+                            data={userSessionInfo}
+                            onFormChange={onFormChangeUserSessionInfo}
+                            setNewData={setNewUserSessionData}
+                        />
+                    ) : (
+                        <SessionGuest
+                            sessionStatus={session?.status ?? null}
+                            sessionInfo={normalizeSesionData(session)}
+                            zones={fetchedSelectZones ?? []}
+                            data={userSessionInfo}
+                            onFormChange={onFormChangeUserSessionInfo}
+                            setNewData={setNewUserSessionData}
+                        />
+                    )}
+                    <ButtonWrapper>
+                        <Buttons
+                            status={session?.status ?? null}
+                            handlePayButton={handlePayButton}
+                            onClick={checkForDoubleClick}
+                        />
+                    </ButtonWrapper>
+                </Wrapper>
+            )}
+        </>
+    );
+};
+
+export default Session;
